<script setup>
import { toast } from 'bulma-toast'

const router = useRouter()
const route = useRoute()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

const client = useCookie('logship_client')
const clientId = useCookie('logship_client_id')
const organization = useCookie('logship_organization')
const organizationId = useCookie('logship_organization_id')

const form = ref({
  id: '',
  uid: '',
  client: client.value?.Name || '',
  clientId: clientId.value || '',
  organization: organization.value?.Name || '',
  organizationId: organizationId.value || '',
  name: '',
  description: '',
  isActive: true,
  value: '',
  isDefault: false,
  plannedMargin: 0.0,
  isSelfService: false,
  assetGroup: '',
  assetGroupId: '',
  printColor: '',
  printColorId: '',
  mMPolicy: '',
  mMPolicyId: '',
  parentProductCategory: '',
  parentProductCategoryId: '',
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false
  }
})

const retrieve = async () => {
  const res = await $fetch('/api/materials/product-categories/'+route.params.id, {
    headers: useRequestHeaders(['cookie'])
  })
  if(res) {
    form.value = {
      id: '',
      uid: '',
      client: res?.AD_Client_ID?.identifier || '',
      clientId: res?.AD_Client_ID?.id || '',
      organization: res?.AD_Org_ID?.identifier || '',
      organizationId: res?.AD_Org_ID?.id || '',
      name: res?.Name || '',
      description: res?.Description || '',
      isActive: true,
      value: '',
      isDefault: false,
      plannedMargin: res?.PlannedMargin || 0.0,
      isSelfService: false,
      assetGroup: res?.A_Asset_Group_ID?.identifier || '',
      assetGroupId: res?.A_Asset_Group_ID?.id || '',
      printColor: res?.AD_PrintColor_ID?.identifier || '',
      printColorId: res?.AD_PrintColor_ID?.id || '',
      mMPolicy: res?.MMPolicy?.identifier || '',
      mMPolicyId: res?.MMPolicy?.id || '',
      parentProductCategory: res?.M_Product_Category_Parent_ID?.identifier || '',
      parentProductCategoryId: res?.M_Product_Category_Parent_ID?.id || '',
      processing: false,
      alert: {
        status: '',
        message: '',
        processing: false
      }
    }
    setActiveSave()
  }
}
onMounted(retrieve)

const setActiveSave = () => {
  if(form.value.name !== '' && form.value.mMPolicyId !== '' && form.value.plannedMargin !== '') {
    activeSave.value = true
  } else {
    activeSave.value = false
  }
}

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/materials/product-categories')
  }
}

const save = async (record) => {
  form.value = record

  setActiveSave()
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/materials/product-categories/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: form.value.organizationId,
      name: form.value.name,
      description: form.value.description,
      isActive: form.value.isActive,
      value: form.value.value,
      isDefault: form.value.isDefault,
      plannedMargin: form.value.plannedMargin,
      isSelfService: form.value.isSelfService,
      assetGroupId: form.value.assetGroupId,
      printColorId: form.value.printColorId,
      mMPolicyId: form.value.mMPolicyId,
      parentProductCategoryId: form.value.parentProductCategoryId,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false

    if(saveType === 'preview') {
      router.push('/materials/product-categories/' + res.id + '/view')
    } else if(saveType === 'changes' || saveType === 'onlysave') {
      router.push('/materials/product-categories/'+res.id+'/edit')
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
    //window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '#', text: 'Materials'},
  { link: '/materials/product-categories', text: 'Product Categories'},
  { link: '#', text: 'Add Product Category', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add Product Category</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    
    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.name === '' || form.mMPolicyId === '' || form.plannedMargin === '' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>

    <div>
      <div class="banner">
        <div>
          <MaterialsProductCategoryForm v-model="form" @save="save"/>
        </div>
        <div class="opacity-0.6 pointerEvents-none">
          <MaterialsProductCategoryDetailRecord action="create" :info="form" />
        </div>
      </div>
    </div>
  </NuxtLayout>
</template>